/* Andrey N. Kuznetsov, Almaty, 2012 *
 * For educational purposes.         *
 * Under GPL 2.0                     */
//---------------------------------------------------------------------
#include "TCentralComponent.h"
//---------------------------------------------------------------------
#define tr(s) String::fromUTF8(s)
//---------------------------------------------------------------------
TCentralComponent::TCentralComponent() : Component("Central Component"),
                                         pShowGreetingButton(0),
                                         pShowCloseButton(0),
                                         pHelloLabel(0),
                                         pCloseButton(0)
{
    // Флажок, отображающий / скрывающий надпись "Привет, мир!"
    pShowGreetingButton = new ToggleButton(tr("Показать приветствие"));
    pShowGreetingButton->addListener(this);
    addAndMakeVisible(pShowGreetingButton);

    // Флажок, отображающий / скрывающий кнопку выхода
    pShowCloseButton = new ToggleButton(tr("Показать кнопку выхода"));
    pShowCloseButton->addListener(this);
    addAndMakeVisible(pShowCloseButton);

    // Надпись - приветствие
    pHelloLabel = new Label("Hello Label", tr("Привет, мир!"));
    addAndMakeVisible(pHelloLabel);
    pHelloLabel->setFont(Font(20.0000f, Font::bold));
    pHelloLabel->setJustificationType(Justification::left);
    pHelloLabel->setEditable(false, false, false);
    pHelloLabel->setColour(Label::textColourId, Colours::blue);
    pHelloLabel->setColour(TextEditor::textColourId, Colours::black);
    pHelloLabel->setColour(TextEditor::backgroundColourId, Colours::azure);

    // Кнопка завершения работы программы
    pCloseButton = new TextButton("Close Button");
    addAndMakeVisible(pCloseButton);
    pCloseButton->setButtonText(tr("Выход"));
    pCloseButton->addListener(this);

    setSize(500, 150);

    // Прячем надпись и кнопку
    pHelloLabel->setVisible(false);
    pCloseButton->setVisible(false);
}
//---------------------------------------------------------------------
TCentralComponent::~TCentralComponent()
{
    deleteAllChildren();
}
//---------------------------------------------------------------------
void TCentralComponent::paint(Graphics& Canvas)
{
    Canvas.fillAll(Colours::azure);
}
//---------------------------------------------------------------------
void TCentralComponent::resized()
{
    pShowGreetingButton->setBounds(10, 10, 200, 25);
    pShowCloseButton->setBounds(10, 40, 200, 25);
    pHelloLabel->setBounds(230, 10, 250, 25);
    pCloseButton->setBounds(230, 80, 150, 25);
}
//---------------------------------------------------------------------
void TCentralComponent::buttonClicked(Button* pButton)
{
    if(pButton == pCloseButton)
    {
        // Выходим...
        JUCEApplication::quit();
    }
    else if(pButton == pShowGreetingButton)
    {
        // Прячем / показываем надпись в зависимости от состояния флажка
        pHelloLabel->setVisible(pShowGreetingButton->getToggleState());
    }
    else if(pButton == pShowCloseButton)
    {
        // Прячем / показываем кнопку выхода 
        // в зависимости от состояния флажка
        pCloseButton->setVisible(pShowCloseButton->getToggleState());
    }
}
//---------------------------------------------------------------------
